package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * UrlCategoryOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class UrlCategoryOpenApiVo   {
  @JsonProperty("categories")
  @Valid
  private Map<String, List<String>> categories = null;

  @JsonProperty("protocolVer")
  private String protocolVer;

  public UrlCategoryOpenApiVo categories(Map<String, List<String>> categories) {
    this.categories = categories;
    return this;
  }

  public UrlCategoryOpenApiVo putCategoriesItem(String key, List<String> categoriesItem) {
    if (this.categories == null) {
      this.categories = new HashMap<>();
    }
    this.categories.put(key, categoriesItem);
    return this;
  }

  /**
   * categories of the URL filtering 5.15
   * @return categories
  */
  @ApiModelProperty(value = "categories of the URL filtering 5.15")

  @Valid

  public Map<String, List<String>> getCategories() {
    return categories;
  }

  public void setCategories(Map<String, List<String>> categories) {
    this.categories = categories;
  }

  public UrlCategoryOpenApiVo protocolVer(String protocolVer) {
    this.protocolVer = protocolVer;
    return this;
  }

  /**
   * protocolVer of the categories.
   * @return protocolVer
  */
  @ApiModelProperty(value = "protocolVer of the categories.")


  public String getProtocolVer() {
    return protocolVer;
  }

  public void setProtocolVer(String protocolVer) {
    this.protocolVer = protocolVer;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UrlCategoryOpenApiVo urlCategoryOpenApiVo = (UrlCategoryOpenApiVo) o;
    return Objects.equals(this.categories, urlCategoryOpenApiVo.categories) &&
        Objects.equals(this.protocolVer, urlCategoryOpenApiVo.protocolVer);
  }

  @Override
  public int hashCode() {
    return Objects.hash(categories, protocolVer);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UrlCategoryOpenApiVo {\n");
    
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    protocolVer: ").append(toIndentedString(protocolVer)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

